package org.dromara.web.service;


import org.dromara.common.core.domain.R;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.web.domain.bo.EnteralNutritionBo;
import org.dromara.web.domain.bo.HospitalMealPlanBo;
import org.dromara.web.domain.vo.*;

import java.util.Collection;
import java.util.List;

/**
 * 院内膳食主Service接口
 *
 * @author Lion Li
 * @date 2025-07-23
 */
public interface IHospitalMealPlanService {

    /**
     * 查询院内膳食主
     *
     * @param id 主键
     * @return 院内膳食主
     */
    HospitalMealPlanVo queryById(Long id);

    /**
     * 分页查询院内膳食主列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 院内膳食主分页列表
     */
    TableDataInfo<HospitalMealPlanVo> queryPageList(HospitalMealPlanBo bo, PageQuery pageQuery);

    /**
     * 查询符合条件的院内膳食主列表
     *
     * @param bo 查询条件
     * @return 院内膳食主列表
     */
    List<HospitalMealPlanVo> queryList(HospitalMealPlanBo bo);

    /**
     * 新增院内膳食主
     *
     * @param bo 院内膳食主
     * @return 是否新增成功
     */
    Boolean insertByBo(HospitalMealPlanBo bo);

    /**
     * 修改院内膳食主
     *
     * @param bo 院内膳食主
     * @return 是否修改成功
     */
    Boolean updateByBo(HospitalMealPlanBo bo);

    /**
     * 校验并批量删除院内膳食主信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    List<HospitalMealRecipeVo> queryBySettlementId(Long id);
    R<List<HospitalMealRecipeVo>> queryById(String ids);
    //手动配置
    R manualConfig(String ids);

    //执行操作
    R execute(String ids);

    //执行操作
    R tagPrint(String ids);

    /**
     * 查询符合条件的肠内营养列表
     *
     * @param bo 查询条件
     * @return 肠内营养列表
     */
    List<HospitalMealRecipeVo> queryList(EnteralNutritionBo bo);

    TableDataInfo<HospitalMealPlanQueryVo> queryHospitalMealPlanList(EnteralNutritionBo bo, PageQuery pageQuery);
}
